题目

Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the bus moves from one city S to another city F. On this way, the tourists in the bus can see the sights alongside the route travelled. Moreover, the bus makes a number of stops (zero or more) at some beautiful cities, where the tourists get out to see the local sights.

Different groups of tourists may have different preferences for the sights they want to see, and thus for the route to be taken from S to F. Therefore, Your Personal Holiday wants to offer its clients a choice from many different routes. As hotels have been booked in advance, the starting city S and the final city F, though, are fixed. Two routes from S to F are considered different if there is at least one road from a city A to a city B which is part of one route, but not of the other route.

There is a restriction on the routes that the tourists may choose from. To leave enough time for the sightseeing at the stops (and to avoid using too much fuel), the bus has to take a short route from S to F. It has to be either a route with minimal distance, or a route which is one distance unit longer than the minimal distance. Indeed, by allowing routes that are one distance unit longer, the tourists may have more choice than by restricting them to exactly the minimal routes. This enhances the impression of a personal holiday.

For example, for the above road map, there are two minimal routes from S = 1 to F = 5: 1 → 2 → 5 and 1 → 3 → 5, both of length 6. There is one route that is one distance unit longer: 1 → 3 → 4 → 5, of length 7.

Now, given a (partial) road map of the Benelux and two cities S and F, tour operator Your Personal Holiday likes to know how many different routes it can offer to its clients, under the above restriction on the route length.

输入格式

The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:

One line with two integers N and M, separated by a single space, with \(2 ≤ N ≤ 1,000\) and \(1 ≤ M ≤ 10, 000\): the number of cities and the number of roads in the road map.

M lines, each with three integers A, B and L, separated by single spaces, with \(1 ≤ A, B ≤ N, A ≠ B\) and \(1 ≤ L ≤ 1,000\), describing a road from city \(A\) to city \(B\) with length \(L\).

The roads are unidirectional. Hence, if there is a road from \(A\) to \(B\), then there is not necessarily also a road from \(B\) to \(A\). There may be different roads from a city A to a city B.

One line with two integers \(S\) and \(F\), separated by a single space, with \(1 ≤ S, F ≤ N\) and \(S ≠ F\): the starting city and the final city of the route.

There will be at least one route from \(S\) to \(F\).

输出格式

For every test case in the input file, the output should contain a single number, on a single line: the number of routes of minimal length or one distance unit longer. Test cases are such, that this number is at most 109 = 1,000,000,000.

输入样例

2
5 8
1 2 3
1 3 2
1 4 5
2 3 1
2 5 3
3 4 2
3 5 4
4 5 3
1 5
5 6
2 3 1
3 2 1
3 1 10
4 5 2
5 2 7
5 2 7
4 1

输出样例

3
2

代码

实际上就是最短路, 但是增加了一个次长路, 也很好解决

在Dijkstra更新时, 每次构建一个新路径, 做一下判断, 不仅更新最短路, 还要更新次短路

记录源点到某点的最短路和次短路

  1. 如果新路径小于最短路, 那么新路径变成最短路, 原来的最短路变成次短路;

  2. 如果新路径等于最短路, 那么最短路方法数+1

  3. 如果新路径大于最短路小于次短路, 更新次短路

  4. 如果新路径等于次短路, 那么次短路方法数+1

代码

#include <cstdio>
#include <cstring>
using namespace std;
const int INF = 0x3f3f3f3f, VM = 1010, EM = 10010;
struct Edge { int to, next, w; } edges[EM << 1];
int dis[VM][2], head[VM], num[VM][2], n, m, cnt;
bool vis[VM][2];
void add(int u, int v, int w) { edges[++cnt] = (Edge){v, head[u], w}, head[u] = cnt; }
void Dijkstra(int s, int e) {
memset(vis, false, sizeof(vis));
memset(num, 0, sizeof(num));
for (int i = 1; i <= n; i++) dis[i][0] = INF, dis[i][1] = INF;
dis[s][0] = 0, num[s][0] = 1;
int p, flag;
for (int i = 1; i <= 2 * n - 1; i++) {
int minn = INF;
for (int j = 1; j <= n; j++) {
if (!vis[j][0] && minn > dis[j][0]) {
flag = 0;
minn = dis[p = j][0];
} else if (!vis[j][1] && minn > dis[j][1]) {
flag = 1;
minn = dis[p = j][1];
}
}
if (minn == INF) break;
vis[p][flag] = true;
for (int j = head[p]; j; j = edges[j].next) {
int v = edges[j].to;
if (dis[v][0] > minn + edges[j].w) {
dis[v][1] = dis[v][0];
num[v][1] = num[v][0];
dis[v][0] = minn + edges[j].w;
num[v][0] = num[p][flag];
} else if (dis[v][0] == minn + edges[j].w)
num[v][0] += num[p][flag];
else if (dis[v][1] > minn + edges[j].w) {
dis[v][1] = minn + edges[j].w;
num[v][1] = num[p][flag];
} else if (dis[v][1] == minn + edges[j].w)
num[v][1] += num[p][flag];
}
}
if (dis[e][1] == dis[e][0] + 1) num[e][0] += num[e][1];
printf("%d\n", num[e][0]);
}
int main() {
int T;
scanf("%d", &T);
while (T--) {
cnt = 0;
memset(head, -1, sizeof(head));
scanf("%d%d", &n, &m);
int u, v, w;
while (m--) {
scanf("%d%d%d", &u, &v, &w);
add(u, v, w);
}
int s, e;
scanf("%d%d", &s, &e);
Dijkstra(s, e);
}
return 0;
}

POJ 3463 Sightseeing 题解的更多相关文章

  1. poj 3463 Sightseeing( 最短路与次短路)

    http://poj.org/problem?id=3463 Sightseeing Time Limit: 2000MS   Memory Limit: 65536K Total Submissio ...

  2. POJ - 3463 Sightseeing 最短路计数+次短路计数

    F - Sightseeing 传送门: POJ - 3463 分析 一句话题意:给你一个有向图,可能有重边,让你求从s到t最短路的条数,如果次短路的长度比最短路的长度多1,那么在加上次短路的条数. ...

  3. poj 3463 Sightseeing——次短路计数

    题目:http://poj.org/problem?id=3463 当然要给一个点记最短路和次短路的长度和方案. 但往优先队列里放的结构体和vis竟然也要区分0/1,就像把一个点拆成两个点了一样. 不 ...

  4. POJ 3463 Sightseeing (次短路经数)

    Sightseeing Time Limit: 2000MS   Memory Limit: 65536K Total Submissions:10005   Accepted: 3523 Descr ...

  5. POJ 3463 Sightseeing 【最短路与次短路】

    题目 Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the ...

  6. poj 3463 Sightseeing(次短路+条数统计)

    /* 对dij的再一次理解 每个点依旧永久标记 只不过这里多搞一维 0 1 表示最短路还是次短路 然后更新次数相当于原来的两倍 更新的时候搞一下就好了 */ #include<iostream& ...

  7. POJ 3463 Sightseeing

    最短路+次短路(Dijkstra+priority_queue) 题意是要求你找出最短路的条数+与最短路仅仅差1的次短路的条数. 開始仅仅会算最短路的条数,和次短路的长度.真是给次短路条数跪了.ORZ ...

  8. POJ 3463 Sightseeing (次短路)

    题意:求两点之间最短路的数目加上比最短路长度大1的路径数目 分析:可以转化为求最短路和次短路的问题,如果次短路比最短路大1,那么结果就是最短路数目加上次短路数目,否则就不加. 求解次短路的过程也是基于 ...

  9. POJ 1637 Sightseeing tour(最大流)

    POJ 1637 Sightseeing tour 题目链接 题意:给一些有向边一些无向边,问能否把无向边定向之后确定一个欧拉回路 思路:这题的模型很的巧妙,转一个http://blog.csdn.n ...

随机推荐

  1. 【Spring注解驱动开发】聊聊Spring注解驱动开发那些事儿!

    写在前面 今天,面了一个工作5年的小伙伴,面试结果不理想啊!也不是我说,工作5年了,问多线程的知识:就只知道继承Thread类和实现Runnable接口!问Java集合,竟然说HashMap是线程安全 ...

  2. 调优 | Apache Hudi应用调优指南

    通过Spark作业将数据写入Hudi时,Spark应用的调优技巧也适用于此.如果要提高性能或可靠性,请牢记以下几点. 输入并行性:Hudi对输入进行分区默认并发度为1500,以确保每个Spark分区都 ...

  3. 用struts的action运行jsp页面

    struts是开源框架.使用Struts的目的是为了帮助我们减少在运用MVC设计模型来开发Web应用的时间.如果我们想混合使用Servlets和JSP的优点来建立可扩展的应用,struts是一个不错的 ...

  4. vue踩过的坑('url' is assigned a value but never used no-unused-vars)

    1.代码编写 2.遇见错误 3.解决方案 在错误代码后加入注释:(// eslint-disable-line no-unused-vars) 之后页面上就不会出现该错误信息了

  5. Java规则引擎 Easy Rules

    1.  Easy Rules 概述 Easy Rules是一个Java规则引擎,灵感来自一篇名为<Should I use a Rules Engine?>的文章 规则引擎就是提供一种可选 ...

  6. Docker+Selenium+TestNG+Maven+Jenkins环境搭建

    一.Selenium环境准备 standalone-chrome Docker容器启动: docker pull selenium/standalone-chrome version: '3' ser ...

  7. Codeforces Round #647 (Div. 2)

    Problem A https://codeforces.com/contest/1362/problem/A 判断x/y是不是2的k次方, 如果是 k/3 + (k%3)/2 + (k%3%2)即为 ...

  8. 使用 LIKE 的模糊查询

    字符串匹配的语法格式如下: <表达式1> [NOT] LIKE <表达式2> 字符串匹配是一种模式匹配,使用运算符 LIKE 设置过滤条件,过滤条件使用通配符进行匹配运算,而不 ...

  9. Java中泛型的继承

    最新在抽取公共方法的时候,遇到了需要使用泛型的情况,但是在搜索了一圈之后,发现大部分博客对于继承都说的不太清楚,所幸还有那么一两篇讲的清楚的,在这里自己标记下. 以我自己用到的代码举例,在父类中使用了 ...

  10. 基于 abp vNext 和 .NET Core 开发博客项目 - Blazor 实战系列(八)

    系列文章 基于 abp vNext 和 .NET Core 开发博客项目 - 使用 abp cli 搭建项目 基于 abp vNext 和 .NET Core 开发博客项目 - 给项目瘦身,让它跑起来 ...